'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Connector = exports.unsubscribe = exports.subscribe = exports.publishable = exports.publish = exports.issue = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _zine = require('zine');

Object.defineProperty(exports, 'issue', {
  enumerable: true,
  get: function get() {
    return _zine.issue;
  }
});
Object.defineProperty(exports, 'publish', {
  enumerable: true,
  get: function get() {
    return _zine.publish;
  }
});
Object.defineProperty(exports, 'publishable', {
  enumerable: true,
  get: function get() {
    return _zine.publishable;
  }
});
Object.defineProperty(exports, 'subscribe', {
  enumerable: true,
  get: function get() {
    return _zine.subscribe;
  }
});
Object.defineProperty(exports, 'unsubscribe', {
  enumerable: true,
  get: function get() {
    return _zine.unsubscribe;
  }
});
exports.connect = connect;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Connector = exports.Connector = function (_React$Component) {
  _inherits(Connector, _React$Component);

  function Connector(props) {
    _classCallCheck(this, Connector);

    var _this = _possibleConstructorReturn(this, (Connector.__proto__ || Object.getPrototypeOf(Connector)).call(this, props));

    _this.canUpdate = true;

    _this.update = function () {
      if (_this.canUpdate) {
        _this.forceUpdate();
      }
    };

    if ((0, _zine.publishable)(_this.props.source)) {
      (0, _zine.subscribe)(_this.props.source, _this.update);
    } else {
      console.warn("Tried to use Connector to subscribe to an unpublishable source: ", _this.props.source);
    }
    return _this;
  }

  _createClass(Connector, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.canUpdate = false; // Prevent updates from triggering re-renders after component decides to unmount
      (0, _zine.unsubscribe)(this.props.source, this.update);
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps) {
      var oldSource = this.props.source;
      var source = nextProps.source;
      if (source !== oldSource) {
        (0, _zine.unsubscribe)(oldSource, this.update);
        if ((0, _zine.publishable)(source)) {
          (0, _zine.subscribe)(source, this.update);
        } else {
          console.warn("Tried to use Connector to subscribe to an unpublishable source: ", source);
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.render(this.props.source, this.props.passProps);
    }
  }]);

  return Connector;
}(_react2.default.Component);

;

Connector.defaultProps = {
  passProps: {},
  render: function render() {
    return null;
  },
  source: undefined
};

function connect(source, render) {
  return function (props) {
    return _react2.default.createElement(Connector, { source: source, render: render, passProps: props });
  };
};
